/**@file testFwDevice.ctl  
  
@brief Example file containing test routines for (one of) the libraries in this component. 
  
@par Creation Date
		 17/06/2014   
  
 */
 
// You must pick up this library:
#uses "fwUnitTestComponentAsserts.ctl"

// and, of course, the library of routines you are wanting to call (ie wanting to test):
#uses "fwDevice/fwDevice.ctl"

/**
@brief A test routine, calls the routine being tested. 
*/ 

// The test case's routine name shall always start with test*
// The name of the routine being tested here, follows the Fw guidelines: LibName_routineName 
// so we call this routine that does the testing testExampleLibToBeTested_sub:
void testFwDevice_evalExpression()
{  
	string expression = "{{one + two + three}}";
	string expectedResultString;
	string resultString;

	dyn_string exceptionInfo;
	mapping variables;
 
	variables["one"]	 	= 1;
	variables["two"]		= 2;
	variables["three"]	= 3;	
  
	expectedResultString = 6;
	resultString =  fwDevice_evalExpression(expression, variables, exceptionInfo);
  
  // The test cases calls an assertion routine from the library fwUnitTestComponentAsserts that we #uses above :
  assertEqual(expectedResultString, resultString);
}

//-------------------------------------------------------

/**
@brief Another example of a developer's test routine. 
*/ 
void testFwDevice_evalExpression2()
{
	string expression = "{{one}} + {{two}} + {{three}}";
	string expectedResultString;
	string resultString;

	dyn_string exceptionInfo;
	mapping variables;
 
	variables["one"]	 	= 1;
	variables["two"]		= 2;
	variables["three"]	= 3;	
  
	expectedResultString = "1 + 2 + 3";
	resultString =  fwDevice_evalExpression(expression, variables, exceptionInfo);
  
  // The test cases calls an assertion routine from the library fwUnitTestComponentAsserts that we #uses above :
  assertEqual(expectedResultString, resultString);
}

//-------------------------------------------------------

/**
@brief Another example of a developer's test routine. 
*/ 
void testFwDevice_evalExpression3()
{
	string expression = "{{one + two + three}}"; //"{{{{one}} + {{two}} + {{three}}}}";
	string expectedResultString;
	string resultString;

	dyn_string exceptionInfo;
	mapping variables;
 
	variables["one"]	 	= 1;
	variables["two"]		= 2;
	variables["three"]	= 3;	
  
	expectedResultString = "6";
	resultString =  fwDevice_evalExpression(expression, variables, exceptionInfo);
  
  // The test cases calls an assertion routine from the library fwUnitTestComponentAsserts that we #uses above :
  assertEqual(expectedResultString, resultString);
}
